unit Unit1;

interface

uses
    Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
    Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
    TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    Button1: TButton;
    Edit1: TEdit;
    Button2: TButton;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    private
        procedure   ListUPMemory;
    public

    end;

var
    Form1: TForm1;

implementation

uses
    WinSock, iNet;

{$R *.dfm}

(*
    ############################################################################

    T[o[ł

    ############################################################################
*)

// -----------------------------------------------------------------------------
// NCAgւ̉pXbh錾
// -----------------------------------------------------------------------------
type
    TClientThread = class(TThread)
    private
        client      : TSocket;
    protected
        procedure   Execute(); override;
    public
        constructor Create(s: TSocket);
    end;

// -----------------------------------------------------------------------------
// NCAgւ̉pXbhRXgN^
// -----------------------------------------------------------------------------
constructor TClientThread.Create(s: TSocket);
begin
    inherited Create(True);
    client := s;
    FreeOnTerminate := True;
    Resume;
end;

// -----------------------------------------------------------------------------
// NCAgւ̉pXbhC
// -----------------------------------------------------------------------------
procedure   TClientThread.Execute();
const
    DEFAULT_HTML = '<html><head><title>WebServer</title></head><body>i''m here!!</body></html>';
var
    html: TStream;
    recvdata: string;
begin
    // @ԂHTMLR[h
    html := TMemoryStream.Create;
    try
        try
            if not GetHtmlSource(html, Form1.Edit2.Text) then
                html.Write(DEFAULT_HTML[1], Length(DEFAULT_HTML));
            try
                // [
                recvdata := recvonce(client);
                // s[
                send(client, html);
            finally
                // \Pbgp
                closesocket(client);
            end;
        finally
            // Xg[p
            html.Free;
        end;
    except
        raise Exception.Create('TClientThread');
    end;
end;


// -----------------------------------------------------------------------------
// gp󋵈ꗗ
// [Delphi:56760] Iz񂪊JȂ
// -----------------------------------------------------------------------------
procedure   TForm1.ListUPMemory;
var
    status  : TMemoryStatus;
    count   : integer;
    size    : integer;
begin
    count := AllocMemCount;
    size := AllocMemSize;
    status.dwLength:= SizeOf(status);
    GlobalMemoryStatus(status);
    Memo1.Clear;
    with status do
    begin
        Memo1.Lines.Add(Format('Imې       %d', [count]));
        Memo1.Lines.Add(Format('Imۗ       %d', [size]));
        Memo1.Lines.Add(Format('gp̃(%%)      %d', [dwMemoryLoad]));
        Memo1.Lines.Add(Format('             %d', [dwTotalPhys]));
        Memo1.Lines.Add(Format('󂫕         %d', [dwAvailPhys]));
        Memo1.Lines.Add(Format('y[WOt@C     %d', [dwTotalPageFile]));
        Memo1.Lines.Add(Format('󂫃y[WOt@C %d', [dwAvailPageFile]));
        Memo1.Lines.Add(Format('[U[         %d', [dwTotalVirtual]));
        Memo1.Lines.Add(Format('󂫃[U[     %d', [dwAvailVirtual]));
    end;
    // ----
    Application.ProcessMessages;
    // ----
end;

// -----------------------------------------------------------------------------
// T[o[C
// -----------------------------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
var
    sock, csock: TSocket;
    sockaddr, csockaddr: TSockAddr;
begin
    try
        // \Pbg쐬
        sock := socket();
        try
            // [͂ǂ?
            ListUPMemory();
            // AhXE|[gw
            sockaddr := MakeSockAddr(80, '');
            // |[gԍƂ̃vZXoCh
            bind(sock, sockaddr);
            // [h
            listen(sock);
            // ivɑ҂
            while true do
            begin
                // ڑ҂
                csock := accept(sock, csockaddr);
                // XbhŃS[
                TClientThread.Create(csock);
            end;
        finally
            // \Pbgp
            closesocket(sock);
        end;
    except
        on E:Exception do Memo1.Lines.Add(E.Message);
    end;
end;

(*
    ############################################################################

    NCAg

    ############################################################################
*)
procedure TForm1.Button2Click(Sender: TObject);
var
    GetCommand: string;
    sock: TSocket;
    sockaddr: TSockAddr;
begin
    try
        // WEBT[o֑M閽
        GetCommand := 'GET /index.html HTTP/1.0'#13#10#13#10;
        // \Pbg쐬
        sock := socket();
        try
            // ڑ̃AhXE|[gw
            sockaddr := MakeSockAddr(80, Edit1.Text);
            // ڑ
            connect(sock, sockaddr);
            // M
            send(sock, GetCommand);
            // M
            recv(sock, Memo1.Lines);
        finally
            // \Pbg̔j
            closesocket(sock);
        end;
    except
        on E:Exception do Memo1.Lines.Add(E.Message);
    end;
end;

end.
